Utility gmax2psp "gmax2psp"
(
	local Lua3DClone
	
	Button Export "Export Lua Structure"
	
	fn ParseModel Obj =
	(
		local ii, temp, origname
		local vertex1, vertex2, vertex3
		
		if SuperClassOf Obj == GeometryClass then
		(
			ObjName = Obj.name
			origname = Obj.name
			
			if ObjName != "Lua3DClone" then
			(
				copy Obj name:"Lua3DClone"
				Obj = $Lua3DClone
				CollapseStack Obj
				ConvertToMesh Obj
				
				if ClassOf Obj.material == MultiMaterial then
				(
				)else if ClassOf Obj.material == StandardMaterial then
				(
					format "%col = Color.new(%,%,%)\n\n" origname Obj.material.diffuse.r Obj.material.diffuse.b Obj.material.diffuse.g
					
					format "% = {\n" origname
					
					ProgressStart ("Processing '" + origname + "'")
					for ii in 1 to Obj.numfaces do
					(
						temp = GetFace Obj ii
					
						vertex1 = (GetVert Obj temp[1])
						vertex2 = (GetVert Obj temp[2])
						vertex3 = (GetVert Obj temp[3])
					
						if ii != Obj.numfaces then
						(
							format "  {%col,%,%,%},\n" origname vertex1[1] vertex1[2] vertex1[3]
							format "  {%col,%,%,%},\n" origname vertex3[1] vertex3[2] vertex3[3]
							format "  {%col,%,%,%},\n" origname vertex2[1] vertex2[2] vertex2[3]
						)else(
							format "  {%col,%,%,%},\n" origname vertex1[1] vertex1[2] vertex1[3]
							format "  {%col,%,%,%},\n" origname vertex3[1] vertex3[2] vertex3[3]
							format "  {%col,%,%,%}\n" origname vertex2[1] vertex2[2] vertex2[3]
						)
						ProgressUpdate (ii * 100 / Obj.numfaces)
					)
					ProgressEnd()
					
					format "}\n\n"
				)
				
				delete $Lua3DClone
			)
		)
	)

  	on Export Pressed do
	(
		local i
		ClearListener()
		if SuperClassOf $frame == GeometryClass then
		(
			if $frame.children.count == 0 then
			(
				MessageBox "Lua3D Error: There is no geometry linked to the frame"
			)else(
				for i in 1 to $frame.children.count do
				(
					if $frame.children[i].material==undefined then
					(
						MessageBox "Lua3D Error: See Listener for Error"
						format "Lua3D Error: % does not have a standard material applied to it.\n" $frame.children[i].name
						exit
					)
					ParseModel $frame.children[i]
				)
			)
		)else(
			MessageBox "Lua3D Error: 'frame' object was not found."
		)
	)
)